<template>
  <div class="report-line-chart">

    <div class="y-axis-label">
      <span>{{ chartLabels.yAxisLabel }}</span>
    </div>

    <div class="report-canvas__wrapper">
      <div :class="`containerBody_${props.indicator}`" style="height: 100% !important">
        <canvas :id="`report-canvas_${props.indicator}`"></canvas>
      </div>
    </div>

  </div>

  <div class="x-axis-label">
    <span>
      {{ chartLabels.xAxisLabel }}
    </span>
  </div>
</template>

<script setup>
import {
  computed,
  reactive,
  watchEffect,
  onMounted,
  toRaw,
} from 'vue';

import {
  Chart as ChartJS,
  registerables
} from 'chart.js';

import getChartLabels from 'src/composables/get_chart_labels';
import getNormalizedName from 'src/composables/get_normalized_name';

ChartJS.register(...registerables);

const props = defineProps({
  data:       { type: Object, required: true },
  indicator:  { type: String, required: true },
});

const localData = computed({
  get: () => toRaw(props.data).reduce((acc, item) => {
    if (item['porcentaje']) {
      acc[`${item['yearmonth']}`] = parseFloat(item['porcentaje']);
    } else if (item['register_number']) {
      acc[`${item['yearmonth']}`] = parseInt(item['register_number']);
    } else if (item['variabilidad']) {
      acc[`${item['yearmonth']}`] = parseFloat(item['variabilidad']);
    }
    return acc
  }, {}),
});

const sort = (obj) => Object.keys(obj)
  .sort()
  .reduce((acc, c) => { acc[c] = obj[c]; return acc }, {});

const makeScaleConfig = () => {
  const minChartDataValue = Math.min(...Object.values(localData.value));
  const maxChartDataValue = Math.max(...Object.values(localData.value));

  if (props.indicator === 'indicator_9') {
    return {
      min: 0,
      suggestedMax: maxChartDataValue,
      ticks: {
        callback: (value) => value + " %",
      },
    };
  } else if (props.indicator === 'indicator_10_11' || props.indicator === 'indicator_14') {

    return {
      min: minChartDataValue,
      suggestedMax: maxChartDataValue,
      ticks: {
        stepSize: 1,
      },
    };
  } else if (props.indicator === 'indicator_15') {
    return {
      suggestedMin: minChartDataValue,
      suggestedMax: maxChartDataValue,
      ticks: {
        callback: (value) => value.toLocaleString('es-EC', {style: 'currency', currency: 'USD'}),
      },
    };
  }
};

const makeChartConfig = () => {
  const data = sort(localData.value);
  const scaleConfig = makeScaleConfig();
  return {
    type: 'line',
    data: {
      labels: Object.keys(data).map(elem => {
        const year = elem.split(".")[0];
        const month = parseInt(elem.split(".")[1]) - 1;
        const monthName = getNormalizedName(month, 'month_short_name');
        return [monthName, year];
      }),
      datasets: [
        {
          data: Object.values(data),
        }
      ]
    },
    options: {
      animation: false,
      animations: {
        colors: false,
        x: false,
      },
      transitions: {
        active: {
          animation: {
            duration: 0,
          }
        }
      },
      resizeDelay: 0,

      responsive: true,
      maintainAspectRatio: false,
      scales: {
        y: scaleConfig,
      },
      elements: {
        line: {
          backgroundColor: '#f26b30',
          borderColor: '#f26b30',
          borderWidth: 2,
        },
        point: {
          radius: 4,
          hoverRadius: 6,
          backgroundColor: '#f26b30',
        },
      },
      plugins: {
        legend: { display: false}
      },
      layout: {
        padding: { left: 10, right: 20 }
      }
    }
  }
}

const chartLabels = getChartLabels(props.indicator);

const canvas_id = `report-canvas_${props.indicator}`;

const createChart = function() {
  let length = data['data']['labels'].length;
  let canvasWidth = length * 20;

  const ctx = document.getElementById(canvas_id);
  ctx.style.width = `${canvasWidth}mm`;

  new ChartJS(ctx, data);
};

let data = reactive({});

watchEffect(() => {
  data = makeChartConfig();
});

onMounted(() => {
  createChart();
});

</script>

<style lang="scss" scoped>
@use './report-line-chart-component-stylesheet.scss';
</style>